#!/usr/bin/perl
###############################################################################
#                                                                             #
# cssaylog.pl - Converts Counter-Strike chat logs to HTML statistics pages    #
#              - Copyright Sergey /KOT/ Sidorin                               #
#              - Distributed under the GPL terms - see the docs for info      #
#              - http://sergey.weblab.ru/projects/cssaylog                    #
#                                                                             #
###############################################################################
#                                                                             #
#    CSSayLog                                                                 #
#    Copyright (C) 2001 Sergey /KOT/ Sidorin <sergey@novsu.ac.ru>             #
#    All Rights Reserved                                                      #
#                                                                             #
#    This program is free software; you can redistribute it and/or modify     #
#    it under the terms of the GNU General Public License as published by     #
#    the Free Software Foundation; either version 2 of the License, or        #
#    (at your option) any later version.                                      #
#                                                                             #
#    This program is distributed in the hope that it will be useful,          #
#    but WITHOUT ANY WARRANTY; without even the implied warranty of           #
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the            #
#    GNU General Public License for more details.                             #
#                                                                             #
#    You should have received a copy of the GNU General Public License        #
#    along with this program; if not, write to the Free Software              #
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA  #
#                                                                             #
###############################################################################

#####  Edit this variables for your environment  ######
$LOGS_DIR = "/usr/local/hlds_l/cstrike/logs";
$WEB_DIR = "/www/cssaylog";
$SERVER_NAME="Your own personal CS Server";
@MONTH_NAMES=("January","February","March","April","May","June","July","August","September","October","November","December");
#####  End of variables  #####




@LOG_DATES = ();
@LOG_FILES = split /\n/, `ls $LOGS_DIR/`;
foreach $line (@LOG_FILES) {
    if ( $line =~ /L(\d\d)(\d\d)(\d\d\d)\.log/ ) {
	($logmonth, $logday) = ($1, $2);
	$LOG_DATES[$logmonth][$logday] = 1;
    }
}

for ($m=1; $m<=12; $m++) {
    for ($d=1; $d<=31; $d++) {
	if ($LOG_DATES[$m][$d] == 1){
	    printf "Processing $m/$d\n";
	    $month = sprintf "%02i", $m;
	    $day = sprintf "%02i", $d;
	    ($logyear, $report) = make_day($year, $month, $day);
	    $filename = "$WEB_DIR/say_$logyear$month$day.html";
	    open(FILE, ">$filename") || die "Can't create $filename";
	    print FILE headers();
	    print FILE $report;
	    print FILE bottom_line();
	    close(FILE);
	}
    }
}


@SAY_PAGES = split /\n/, `ls $WEB_DIR | grep say_ | sort -r`;
%YEARS = ();

foreach $page (@SAY_PAGES) {
    if ($page =~ /say_(\d\d\d\d)(\d\d)(\d\d)\.html/) {
	($year,$month,$day) = ($1,$2,$3);
	$YEARS{$year}[$month][$day]=$page;
    }
}

$calendar = "";
@years = reverse sort keys %YEARS;
foreach $year (@years) {
    $calendar.="
<h1>Year $year</h1>
<table border=0 cellpadding=10 cellspacing=0 width=100%>
";
    for ($m=1; $m<=12; $m++) {
	if ($m%4 == 1) {
	    $calendar.="<tr>";
	}
	$date = "-v".$year."y -v".$m."m -v1d";
	($firstday) = split /:/, `date -j $date \"+%w:\"`;
	$firstday = ($firstday+6)%7 + 1;
	$calendar.="
<td akign=center valign=top>
<table border=0 cellpadding=1 cellspacing=0 width=140>
<tr><td colspan=7 class=head>".$MONTH_NAMES[$m-1]."</td>
<tr>
<td width=20></td>
<td width=20></td>
<td width=20></td>
<td width=20></td>
<td width=20></td>
<td width=20></td>
<td width=20></td>
<tr>
";
	for ($i=1; $i<$firstday; $i++) {
	    $calendar.="<td></td>";
	}

	$q = "date -v".$year."y -v".$m."m -v1d -v+1m -v-1d \"+%d:\"";
	($lastday) = split /:/, `$q`;
	for ($d=1; $d<=$lastday; $d++, $firstday++) {
	    if ($firstday%7 == 1 && $d!=1) {
		$calendar.="<tr>";
	    }
	    $page = $YEARS{$year}[$m][$d];
	    if ($firstday%7 == 0 || $firstday%7 == 6) {
		$calendar.="<td class=weekend>";
	    } else {
		$calendar.="<td>";
	    }
	    if ($page) {
		$calendar.="<a href=$page>$d</a>";
	    } else {
		$calendar.="$d";
	    }
	    $calendar.="</td>";
	}
	$calendar.="
</table>
</td>
";
    }
    $calendar.="</table>";
}

open(FILE, ">$WEB_DIR/index.html") || die "Can't open index";
print FILE headers();
print FILE $calendar;
print FILE bottom_line();
close(FILE);



sub make_day {
    my $month, $day;
    my $report;

    $month = $_[1];
    $day = $_[2];

$table="
<table border=0 cellpadding=2 cellspacing=0 width=100%>
<tr><td></td><td></td><td width=100%></td>
";

    @say_data = split /\n/, `cat $LOGS_DIR/L$month$day*.log | egrep \"(T>\\\" say \\\"|Server say \\\")\"`;
    $line_count = 0;
    foreach $line (@say_data) {
	$passed = 0;
	if ( $line =~ /^L (\d+)\/(\d+)\/(\d+) - (\d+):(\d+):(\d+): \"(.+)<(\d+)><(\d+)><(\w+)>\" (say\w*) \"(.*)\"(.*)$/ ) {
	    ($lmonth, $lday, $lyear, $lhour, $lminute, $lsecond, $lname, $lnumber, $lwonid, $lteam, $action, $lphrase, $ldead) =
		($1, $2, $3, $4, $5, $6, $7, $8, $9, $10, $11, $12, $13);
	    $passed = 1;
	}
	elsif ( $line =~ /^L (\d+)\/(\d+)\/(\d+) - (\d+):(\d+):(\d+): Server say (.*)$/ ) {
	    ($lmonth, $lday, $lyear, $lhour, $lminute, $lsecond, $lname, $lnumber, $lwonid, $lteam, $action, $lphrase, $ldead) =
		($1, $2, $3, $4, $5, $6, $SERVER_NAME, "", "", "SERVER", "", $7, "");
	    $passed = 1;
	}
	if ( $passed == 1 ) {
	    $lphrase =~ s/&/&amp;/g;
	    $lphrase =~ s/</&lt;/g;
	    $lphrase =~ s/>/&gt;/g;
	    
	    if ( $line_count%6 < 3 ) { $line_type = 1; } else { $line_type = 0; }
	    $line_count++;
	    $table.= "<tr class=line$line_type>\n";
	    $table.= "<td class=time>$lhour:$lminute:$lsecond</td>\n";
	    $table.= "<td class=$lteam><nobr>$lname";
	    if ( $ldead eq " (dead)" ) {
		$report.= " <span class=dead>*dead*</span>";
	    }
	    $table.= " </td>\n";
	    $table.= "<td>$lphrase</td>\n";
	}
    }
    $table.= "</table>\n";

    $report = "<a href=index.html>return</a>
<h1>Chat logs for $month/$day/$lyear on $SERVER_NAME</h1>\n".$table;

    return ($lyear, $report);
}


sub headers {
    my $result;
    $result="
<link rel=StyleSheet href=cssaylog.css>
<div align=center>
<h1>Chat logs</h1>
</div>
<hr>";

    return $result;
}


sub bottom_line {
    my $result;
    $result="<div align=center>
<hr>
generated with <a href=http://sergey.weblab.ru/projects/cssaylog/>CSSayLog 0.1</a><br>
&copy 2001, <a href=mailto:sergey\@novsu.ac.ru>Sergey /KOT/ Sidorin</a><br>
</div>";

    return $result;
}
